/*
rbf_nn.hh

This C++ header file defines the class RBF_NN_MODULE
It was generated with the RCS-Design tool.
Template Version 1.1

MODIFICATIONS:
Wed Dec 20 17:11:22 EST 2000	Created by RCS-Design tool.

*/

// Prevent Multiple Inclusion
#ifndef RBF_NN_HH
#define RBF_NN_HH

// Include Files
#include "rcs.hh" 	// Common RCS definitions
#include "nml_mod.hh" 	// NML_MODULE definitions
#include "rbf.hh" // RBF
// RCS-Design-MERGE-DISABLE Edits to the following area will NOT be preserved by the RCS-Design tool.


#include "rbf_nnn.hh" 	// NML Commands and Status definitions for rbf_nn
// RCS-Design-MERGE-ENABLE Edits after this line will be preserved by the RCS-Design tool.


class RBF_NN_MODULE: public NML_MODULE
{
	// RCS-Design-MERGE-DISABLE Edits to the following area will NOT be preserved by the RCS-Design tool.

public:

	RBF_NN_MODULE(int _is_base_class = 0); // Constructor

	// Overloaded Virtual Functions
	virtual void PRE_PROCESS();
	virtual void DECISION_PROCESS();
	virtual void POST_PROCESS();
	virtual void INITIALIZE_NML();

	// Command Functions
	virtual void INIT(RBF_NN_INIT *);
	virtual void HALT(RBF_NN_HALT *);
	virtual void RUN(RBF_NN_RUN *);
	virtual void SET_ADAPTATION_GAIN(RBF_NN_SET_ADAPTATION_GAIN *);
	virtual void SET_CENTERS(RBF_NN_SET_CENTERS *);
	virtual void SET_OUT_PARAMS(RBF_NN_SET_OUT_PARAMS *);
	virtual void SET_SPREADS(RBF_NN_SET_SPREADS *);

	// Convenience Variables
	RBF_NN_STATUS *rbf_nn_status;
	// RCS-Design-MERGE-ENABLE Edits after this line will be preserved by the RCS-Design tool.


private:
	// Add custom variables and functions here.
  int num_of_inputs;
  int num_of_outputs;
  int num_of_neurons;

  RBF *rbf;

  double sys_inputs[NUM_OF_INPUTS];
  double sys_outputs[NUM_OF_OUTPUTS];

  double output_errors[NUM_OF_OUTPUTS];

  double **temp;

};

#endif 	// RBF_NN_HH

